<?

/* this library stored all the function used to process the different html
template we use in easysellingsite */

/* this function will build dynamicaly the images of the categories
folders. Namely this function is currently not in use for compatibility
reason beetween php3 and php4

$categories = table with in each row the name of one categorie 
*/

function faire_image($categories)
{

/* for each categories name */

   while (list($key,$value) = each ($categories))
   {
//      echo $value;
      $nom_categorie = ereg_replace("_"," ",$value);
      $nom_image = $value . '.gif';

      $image = imagecreate(100,30);
      $imagesrc = imagecreatefromgif($pathsrc);
      $dimension = getimagesize($pathsrc);

      imagecopyresized($image,$imagesrc,0,0,0,0,100,30,$dimension[0],$dimension[1]);

      $white = ImageColorAllocate($image, 255,255,255);
      $black = ImageColorAllocate($image, 0,0,0);
      imagecolortransparent($image,$white);

      imagestring ($image,2,50 - strlen($nom_categorie) * 3,8,$nom_categorie,$black);
      imagegif ($image,"$pathdst/$nom_image");

      imagedestroy($image);
      imagedestroy($imagesrc);
   }
}


/* this function load all the available templates in the directory 
$rep_templates */

function initialiser_template ($rep_templates)
{
   // fetch all the templates in the directory
   $contenu = lire_repertoire($rep_templates);
   $template = $contenu['template'];
   
   /* initialize the template */
   $tpl = new FastTemplate ($rep_templates);
   
   while (list($key,$value) = each ($template))
   {
       $partie = explode (".",$value);
       
       $table["$partie[0]"] = $value;
   }
   
   /* add all templates files to the template object $tpl */
   $tpl->define($table);
   
   /* return the object $tpl */
   return ($tpl);
}

/* in case of error, we just write "error" in the page */

function erreur ($tpl)
{
    $tpl->parse(ERREUR,"error");
    
    return ($tpl->fetch);
}

/* it's use to build the categories at the top of each page 
$tpl = the importated templates
$contenu = the array that contains every existing categorie 
*/

function parser_rubrique ($tpl,$contenu)
{
   $nombre = 0;
    
    /* for each categorie */
    
    if (strcmp ($contenu,'no result') != 0)
    {
     while (list($key,$value) = each($contenu))
     {
        // the path of the image that will be associated with the given categorie
      	 
       $image = "/shared/$value[0].gif";
       
       $nombre ++;
       
       // the value associated with the template for each categorie
       
       $tpl->assign(
                  array (
		      IMAGE_RUBRIQUE => $image,
		      REPERTOIRE => "/objet.php3?id_categorie=$value[1]",
		      NOM_REPERTOIRE => ''
			)
		 );
       
       /* and ... one categorie more parsed */
       $tpl->parse(RUBRIQUE,".rubrique");
    }
    /* the html content of the yet parsed categories part */
    $return['contenu'] = $tpl->fetch("RUBRIQUE");
    
    /* the number + 1 of the parsed categories (+1 is for the a better
looking templates in the resulting page) */

    $return['nombre'] = $nombre + 1;
   }
   
    return($return);
}

/* this function will parse all the different contents (templates) and
produce the entire page, this is the final process 
$tpl = the templates variable
$rubrique = the categorie template (already parsed)
$lien = the link templates (actually contains only the search form)
$content = the content of the page (a list of objects or one object
description)
$title = the title we want to give to this page
*/

function parser_contenu ($tpl,$rubrique,$lien,$contenu,$title = 'selling site')
{
   /* the categorie template content */
   $RUBRIQUE = $rubrique['contenu'];
   
   /* the number of categories */
   $NB_RUBRIQUE = $rubrique['nombre'];
   
   $LIEN = $lien['contenu'];
   
   /* parsing of the search form */
   $tpl->parse(LIENS, "recherche");
   
   /* the number of rows used to display the form */
   $NB_LIEN = $lien['nombre'];
  
   /* the content of the page (list or description) */
   $CONTENU = $contenu;
   
   /* parsing */
   $tpl->assign(
               array(
	            RUBRIQUE => $RUBRIQUE,
		    NB_RUBRIQUE => $NB_RUBRIQUE,
		    LIEN => $LIEN,
		    NB_LIEN => $NB_LIEN,
		    CONTENU => $CONTENU,
		    TITLE => $title
		    )
	       );
   
    
   /* parsing of the rest */
   $tpl->parse(BODY,"table_general");
   
   /* parsing of the header */
   $tpl->parse(MAIN,"header");
   
   /* return the entire page to the calling function */
   return($tpl->fetch("MAIN"));
}


/* this function will make the page for the description of one object 
$tpl = the template variable
$connection = the connection handler
$id = the id of the object
*/

function faire_objet ($tpl,$connection,$id)
{
    /* fetch all the information from of object from the database */
    $resultat = recuperer_objet($connection,$id);
    
    /* initialise the templates */
    $tpl->assign(
                array(
		    TITRE => $resultat[0],
		    TITREEN => urlencode ($resultat[0]),
		    IMAGE => $resultat[1],
		    IMAGEEN => urlencode ($resultat[1]),
		    DESCRIPTION => $resultat[2],
		    PRIX => $resultat[3],
		    LONGUEUR => $resultat[4],
		    LARGEUR => $resultat[5],
		    HAUTEUR => $resultat[6],
		    ID_OBJET => $id,
		    PAGE_NUMBER => $PAGE_NUMBER
		    )
		);
    
    /* fetch the categories */
    $categorie = recuperer_categorie($connection,$resultat[7],'null');
    
    $nom_template = (strcmp($categorie[0],'fr') == 0 ? 'objetfr' : 'objetus');
    
    $tpl->parse(OUT,$nom_template);
    
    $rubrique = recuperer_toute_categorie($connection,'null',$categorie[0]);
    
    $rubrique = parser_rubrique($tpl,$rubrique);
    
    $lien['contenu']='';
    $lien['nombre']=5;
    
    $contenu = parser_contenu ($tpl,$rubrique,$lien,$tpl->fetch("OUT"));
    
    return($contenu);
}

/* this function will parse the page for a display of a list of categorie
contained in a categorie

$tpl : the template object
$connection : the connection handler to the database
$id_categorie : the id of the categorie to display
$sup_categorie : the father categorie of this categorie (not yet used)
$begin : the first object to display (usually 0)
$end : the last object to display in the first page, this number determines the amount of object to display by page
$suivant_possible : true or false depending if we have already reach the end of the list
*/

function parser_liste ($tpl,$connection,$resultat,$id_categorie,$sup_categorie,$begin,$end,$suivant_possible)
{
    
    /* the user is doing a search in the database */
    if (strcmp($id_categorie,'recherche') == 0)
    {
        $recherche = 1;
    }
    else
    {
     /* fetch the language used to display this categorie */
     
        $langue = recuperer_categorie($connection,$id_categorie,$sup_categorie);
	$le = (strcmp($langue[0],'fr') == 0 ? 'fr' : 'us');
	$nom_template = "liste$le";
    }
    
    /* compute the number of object per page to display */
    $ecart = $end - $begin;
    
/***************************************************************/    
/* parsing of the communication links to display               */
/***************************************************************/    
    
    if (($begin - $ecart) >= 0)
    {
        $begin_pre = $begin - $ecart;
	$end_pre = $end - $ecart;
    
        $tpl->assign(
	             array(
		          PRECEDENT => "begin=$begin_pre&end=$end_pre"
			  )
		    );
	
	$template_precedent = "precedent$le";
	
	$tpl->parse(LIEN_PRECEDENT, $template_precedent);
    }
    else
    {
        $tpl->assign(
	             array(
		          LIEN_PRECEDENT => ''
			  )
		    );
    }   
    
    if ($suivant_possible == 1)
    {
       $begin_sui = $begin + $ecart;
       $end_sui = $end + $ecart;
       
       $tpl->assign(
	             array(
		          SUIVANT => "begin=$begin_sui&end=$end_sui"
			  )
		    );
	
	$template_suivant = "suivant$le";
	
	$tpl->parse(LIEN_SUIVANT, $template_suivant);
    }
    else
    {
       $tpl->assign(
	             array(
		          LIEN_SUIVANT => ''
			  )
		    );
    }

/**************************************************************/
    
    /* add the phrase "list of items with very attractive prices" */
    
    if (ereg('indexfr',$id_categorie))
    {
       $addon = "<p align=\"center\"><h2><font face=\"Arial, Helvetica,
       sans-serif\" size=\"+2\" color=\"red\">Les bonnes affaires du
       moment</font></h2></p>";
    }
    elseif (ereg ('indexus',$id_categorie))
    {
       $addon = "<p align=\"center\"><h2><font face=\"Arial,Helvetica,
       sans-serif\" size=\"+2\" color=\"red\">list of items with very
       attractive prices</font></h2></p>";
    }
    else
    {
       $addon = '';
    }
    
    /* if there is at list one object contained in this categorie we display
    them */
    
    if (strcmp($resultat,'no result') != 0)
    {
       while (list($key,$value) = each ($resultat))
       {	
           $image = 'small_' . $value[4];
	   
	   
	   $tpl->assign(
	               array(
		         ADDON => $addon,
		         LIEN_OBJET => "objet.php3?id_objet=$value[0]",
			 IMAGE_OBJET => $image,
			 TITRE => $value[1],
			 DESCRIPTION => $value[2],
			 PRIX => $value[3],
			 ID_CATEGORIE => $id_categorie
			 )
		      );
	
            if (isset($recherche))
	    {
	        $tpl->parse(OBJET,".recherche_ligne");
	    }
	    else
	    {
	        $tpl->parse(OBJET,".objet");
	    }
        }
    }
    
   
    /* not used in the current context but can namely be useful if we want
    to add something random in our pages (an advertising banner for example)
    */
    
    $PAGE_NUMBER = rand(1,99);
    
    $tpl->assign(
                array(
		   PAGE_NUMBER => $PAGE_NUMBER
		     )
		);
    
    if (isset($recherche))
    {
        $nom_template = 'recherche_table';
	$rubrique['contenu'] = '';
	$rubrique['nombre'] = 1;
    }
    else
    {	 
	 #if (strcmp($sup_categorie,'null') == 0)
         #{
         #    $sup_categorie = $langue[0];   
	 #}
	 
	 $rubrique = recuperer_toute_categorie($connection,$le,$sup_categorie);
	 $rubrique = parser_rubrique($tpl,$rubrique);
    }
    
    if (strcmp($resultat,'no result') == 0)
       $nom_template = 'pas_de_resultat';
       
    $tpl->parse(OUT,$nom_template);
    
       
    
    $lien['contenu'] = '';
    $lien['nombre'] = 5;
    
    
    $contenu = parser_contenu($tpl,$rubrique,$lien,$tpl->fetch("OUT"));

    
    return ($contenu);
}

/* display the result of a search query 
$tpl : the template object
$connection : the connection handler
$search_string : the search string enter by the user
$debut : the fist object to display (usually 0)
$fin : the last object to display in the first page 
*/

function faire_recherche($tpl,$connection,$search_string,$debut,$fin)
{
    $resultat = recherche($connection,$search_string,$debut,$fin);
    
    return(parser_liste($tpl,$connection,$resultat,'recherche','null',$debut,$fin,0));
}


/* display the content of one categorie 

$tpl : the template object
$connection : the connection handler
$id_categorie : the id of the categorie to display
$debut : the fist object to display (usually 0)
$fin : the last object to display in the first page 

*/

function faire_liste ($tpl,$connection,$id_categorie,$sup_categorie,$debut,$fin)
{
    $resultat = recuperer_liste($connection,$id_categorie,$sup_categorie,$debut,$fin + 1);
   
   
    if (count($resultat) < ($fin - $debut + 1))  #liste suivante vide
    {
       $suivant_possible = 0;
    }
    else
    {
       $suivant_possible = 1;
    }
    
    return(parser_liste ($tpl,$connection,$resultat,$id_categorie,$sup_categorie,$debut,$fin,$suivant_possible));

}

?>
