<?

/* this file is a collection of the database realated function */

/***************************************************************************/


/* connect to the mysql databse (fill in your correct host, login and
password value) */
function connection()
{
   include 'include/config.inc';
   return (mysql_connect($host,$database_user,$user_password));
}

/* issue an sql query to the database $lh=connection handler   and $sql =
sql query */

function requette($lh,$sql)
{
   include 'include/config.inc';
   return (mysql_db_query($database_name,$sql,$lh));
}

/* retrieve the information from a previous query (function requette)
$resultat = result from a previous call to requette */

function recuperer($resultat)
{
   return (mysql_fetch_row($resultat));
}

/* close a mysql cursor */

function terminer_requette($resultat)
{
   mysql_free_result($resultat);
}

/* deconnect from the database */

function deconnection($link)
{
  mysql_close($link);
} 


/* use to fetch the list of object corresponding to our query
$connection = database connection handler
$id_categorie = the categorie of the id we want to fetch the objects
$sup_categorie = the superior categorie of the current sub_categorie (not yet implemented)
$debut = the first object we want to fetch (normally set to 0)
$fin = the last object we want to show in one page (10 objects per page
sould be ok)
*/


function recuperer_liste($connection,$id_categorie,$sup_categorie,$debut,$fin,$premiere_page=0)
{ 

/* the current categorie is the index list (only the best ratio beetween
price and value are listed) */

    if (ereg("index",$id_categorie))
    {
       $sql = "SELECT id_objet as id, nom_de_objet as titre, description,
       prix, image FROM objet WHERE premiere_page=1 ORDER BY id DESC";
    }
    
    /* the user want to have the list of one categorie */
    
    else
    {
         $sql = "SELECT id_objet as id, nom_de_objet as titre, description, prix,
	 image FROM objet WHERE id_categorie=$id_categorie ORDER BY id DESC";
    }
    
    /* we fetch the result */
    
    $resultat = requette($connection,$sql);
    $count = 0;
    
    /* for each object fetched */
    
    while (($ligne = recuperer($resultat)) && ($count < $fin))
    {
        /* only the object that belong to the current page are stored */
	
	if ($count >= $debut)
	{
	
	/* it's important to have this data not equal to null, thus we write	
	"not given" */
	
	   if ($ligne[3] == 0)
	      $ligne[3] = '<i>not given</i>';
	      
	   $return[] = $ligne;
	}
	
	$count ++;
    }
    
    /* we can close now the cursor */
    
    terminer_requette($resultat);
    
    /* if we haven't fetch anything we say "no result" to the calling
    function */  
    
    if ($count > 0)
       return ($return);
    else
       return('no result');
}

/* this function is used to fetch all the categorie that will be displayed 
$connection = the connection handler (given by the connection function)
$language = the language of the categorie we want to display
$sup_categorie = the current father categorie
*/

function recuperer_toute_categorie($connection,$language,$sup_categorie)
{
   /* the sql sentence for it */
   
   $sql = "SELECT nom,id FROM categorie WHERE language='$language' 
   ORDER BY nom ASC";
 
   /* fetching of the result */
   
   $resultat = requette($connection,$sql);
   $count = 0;
   
   /* for each categorie */
   
   while($contenu = recuperer($resultat))
   {
    /* we replace the "_" with an " " and we store it */
    
      $contenu[0] = ereg_replace(" ","_",$contenu[0]);
      $return[] = $contenu;
      
      $count ++;
   }
   
   /* we can close the cursor */
   
   terminer_requette($resultat);
   
   /* and return the result */
   
   if ($count > 0)
      return($return);
   else
       return('no result');
}

function recuperer_categorie($connection,$id_categorie,$sup_categorie)
{
   $sql = "SELECT language FROM categorie";

   if (strcmp($id_categorie,'null') == 0)
   {
      $sql .= " WHERE sup_categorie=$sup_categorie";
   }
   elseif (ereg("fr",$id_categorie))
   {
      return(array('fr',0));
   }
   elseif (ereg("us",$id_categorie))
   {
      return(array('en',0));
   }
   else
   {
      $sql .= " WHERE id=$id_categorie";
   }
   
   $resultat = requette($connection,$sql);
   
   $contenu = recuperer($resultat);
   
   terminer_requette($resultat);
   
   return($contenu);
}


/* this function is used to fetch all the object matching a search string
entered by the user 
$connection = connection handler
$search_string = the search string entered by the user
$debut = the first result we want to display (usually 0)
$fin = the last result in one page we want to display (10 will show 10
object per page)
*/

function recherche ($connection,$search_string,$debut,$fin)
{

/* the sql sentence to that */

   $sql = "SELECT id_objet as id, nom_de_objet as titre, description, prix, image
   FROM objet WHERE
   nom_de_objet LIKE '%$search_string%' OR
   description LIKE '%$search_string%'
   ";


/* fetching the result */

   $resultat = requette($connection,$sql);
   
   $count = 0;

/* for each object fetched */

   while(($contenu = recuperer($resultat)) && ($count < $fin))
   {
   /* we look wether it belongs to the current page */
   
     if ($count >= $debut)
     {
     /* we must give a value to this field */
       if ($contenu[3] == 0)
          $contenu[3] = '<i> not given </i>';
	  
       $return[] = $contenu;
     }
     
     /* one object more fetched */
     
     $count ++;
   }
   
   /* closing of the cursor */
   
   terminer_requette($resultat);
   
   /* if we don't have result ... we say "no result" to the calling function */
   
   if ($count > 0)
      return($return);
   else
      return('no result');
}

/* this function fetch the description from one object 
$connection = the connection handler
$id_object = the id from the object
*/


function recuperer_objet($connection,$id_objet)
{
/* the sql sentence */
   $sql = "SELECT nom_de_objet as titre, image, description, prix, 
   longueur, largeur, hauteur,id_categorie FROM objet WHERE id_objet = $id_objet";
   
   /* fetching of the result */
   
   $resultat = requette($connection,$sql);
   
   $contenu = recuperer($resultat);
   
//   this fields should not have a NULL value
   
   if ($contenu[3] == 0)
      $contenu[3] = '<i>not given</i>';
   
   if ($contenu[4] == 0)
      $contenu[4] = '<i>not given</i>';
   
   if ($contenu[5] == 0)
      $contenu[5] = '<i>not given</i>';
      
   if ($contenu[6] == 0)
      $contenu[6] = '<i>not given</i>';
   
   /* closing the cursor */
   
   terminer_requette($resultat);
   
   /* returning the result */
   
   return($contenu);
}

?>	
